<template>
  <q-card flat bordered class="items-start">
    <q-card-section class="justify-between" horizontal>
      <div class="q-pa-sm">
        <div class="text-h6">{{name}}</div>
        <div class="text-subtitle2">Creado el {{createdAt}}</div>
      </div>
      <div class="col-auto">
        <q-btn color="grey-7" round flat icon="more_vert">
          <q-menu cover auto-close>
            <q-list>
              <q-item clickable v-on:click="editQuiz">
                <q-item-section>Copiar evaluación</q-item-section>
              </q-item>
              <q-item clickable v-on:click="exportQuiz">
                <q-item-section>Exportar a Prueba a PDF</q-item-section>
              </q-item>
              <q-item clickable v-on:click="exportPauta">
                <q-item-section>Exportar a Pauta a PDF</q-item-section>
              </q-item>
              <q-item clickable v-on:click="exportJson">
                <q-item-section>Exportar a Json</q-item-section>
              </q-item>
            </q-list>
          </q-menu>
        </q-btn>
      </div>
    </q-card-section>
    <q-separator inset />
    <q-card-section>
      <div class="text-body1">Cantidad de Preguntas: {{ this.totalQuestions }}</div>
      <div class="text-body1">Puntaje total: {{ this.totalPoints }}</div>
      <div class="text-body1">Etiquetas:</div>
      <div class="row">
        <div
          v-for="(label, index) in labels"
          v-bind:key="index"
          class="q-pl-md"
        >
          <div class="text-body2"> <q-icon name="assignment_turned_in" class="text-positive"/> {{label}} </div>
        </div>
      </div>
    </q-card-section>
</q-card>
</template>

<script>
import { saveAs } from 'file-saver'
export default {
  name: 'QuizCard',
  props: ['quiz', 'createdAt', 'name', 'questions', 'totalQuestions', 'totalPoints', 'labels'],
  methods: {
    editQuiz () {
      this.$store.dispatch('current/setLocalQuiz', this.quiz)
        .then(() => this.$router.push({ path: '/quiz/revision/update' }))
        .catch(error => console.log(error))
    },
    exportQuiz () {
      this.$connection.post('api/quiz/quizToPDF', this.quiz, {}, 'arraybuffer')
        .then((res) => {
          saveAs(new Blob([res.data], { type: 'application/pdf' }), 'quiz_' + this.quiz.name + '.pdf')
        })
    },
    exportPauta () {
      this.$connection.post('api/quiz/pautaToPDF', this.quiz, {}, 'arraybuffer')
        .then((res) => {
          saveAs(new Blob([res.data], { type: 'application/pdf' }), 'pauta_' + this.quiz.name + '.pdf')
        })
    },
    exportJson () {
      this.$connection.post('api/quiz/toJson', this.quiz, {}, 'arraybuffer')
        .then((res) => {
          saveAs(new Blob([res.data], { type: 'application/json;charset=utf-8' }), 'quiz_json_' + this.quiz.name + '.json')
        })
    }
  }
}
</script>
